'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _createExtendable = require('./util/createExtendable');

var _createExtendable2 = _interopRequireDefault(_createExtendable);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// copy all attributes from an immutable.list to an extendable.list
function copy(val, immutable) {
  val.size = immutable.size;
  val._root = immutable._root;
  val.__ownerID = immutable.__ownerID;
  val.__hash = immutable.__hash;
  val.__altered = immutable.__altered;

  return val;
}

function empty(val) {
  val.size = 0;
  val._root = undefined;
  val.__ownerID = undefined;
  val.__hash = undefined;
  val.__altered = false;

  return val;
}

function Map(val) {
  return this.__wrapImmutable(new _immutable.Map(val));
}

Map.isMap = function isMap(obj) {
  return obj && obj instanceof Map;
};

// Inherit methods from Immutable.Map
Map.prototype = (0, _createExtendable2.default)(_immutable.Map, copy, empty);
Map.prototype.constructor = Map;

Map.prototype.toString = function toString() {
  return this.__toString('Extendable.Map {', '}');
};

exports.default = Map;