'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _createExtendable = require('./util/createExtendable');

var _createExtendable2 = _interopRequireDefault(_createExtendable);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EMPTY_LIST = new _immutable.List();
var EMPTY_MAP = new _immutable.Map();

// Copy all attributes from an Immutable.List to an Extendable.List
function copy(val, immutable) {
  val.size = immutable.size;
  val._list = immutable._list;
  val._map = immutable._map;
  val.__ownerID = immutable.__ownerID;
  val.__hash = immutable.__hash;

  return val;
}

function empty(val) {
  val.size = 0;
  val._list = EMPTY_LIST;
  val._map = EMPTY_MAP;
  val.__ownerID = undefined;
  val.__hash = undefined;

  return val;
}

function OrderedMap(val) {
  return this.__wrapImmutable(new _immutable.OrderedMap(val));
}

OrderedMap.isOrderedMap = function isOrderedMap(obj) {
  return obj && obj instanceof OrderedMap;
};

// Inherit methods from Immutable.OrderedMap
OrderedMap.prototype = (0, _createExtendable2.default)(_immutable.OrderedMap, copy, empty);
OrderedMap.prototype.constructor = OrderedMap;

OrderedMap.prototype.toString = function toString() {
  return this.__toString('Extendable.OrderedMap {', '}');
};

exports.default = OrderedMap;