'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _createExtendable = require('./util/createExtendable');

var _createExtendable2 = _interopRequireDefault(_createExtendable);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EMPTY_MAP = new _immutable.Map();

// Copy all attributes from an Immutable.List to an Extendable.List
function copy(val, immutable) {
  val.size = immutable.size;
  val._map = immutable._map;
  val.__ownerID = immutable.__ownerID;

  return val;
}

function empty(val) {
  val.size = 0;
  val._map = EMPTY_MAP;
  val.__ownerID = undefined;

  return val;
}

function Set(val) {
  return this.__wrapImmutable(new _immutable.Set(val));
}

Set.isSet = function isSet(obj) {
  return obj && obj instanceof Set;
};

// Inherit methods from Immutable.OrderedMap
Set.prototype = (0, _createExtendable2.default)(_immutable.Set, copy, empty);
Set.prototype.constructor = Set;

Set.prototype.toString = function toString() {
  return this.__toString('Extendable.Set {', '}');
};

exports.default = Set;